using Flux
using Printf
using LinearAlgebra
using Random
Random.seed!(0)

include("to_one_hot.jl")
include("readclassjson.jl")
include("nn_multiclass_classification.jl")

data = readclassjson("zoo.json")
X_train = Float32.(data["X_train"])
X_test = Float32.(data["X_test"])
y_train = Float32.(data["y_train"])
y_test = Float32.(data["y_test"])
n_classes = 7

# This function takes a vector with positive integer entries
#  and one-hot encodes the vector such that integer k translates
#  to the kth entry of the one-hot encodiding is 1
function int_to_one_hot(v)
    v = Int64.(v)
    return I(maximum(v))[v,:]
end

# This function reverses int_to_one_hot
function one_hot_to_int(v)
    return Float32.(argmax.(eachrow(v)))
end

# Error rate function
function error_rate(yhat, y)
    return sum(yhat .!= y) / length(y)
end

predictall(model,X) = vcat([model(x)' for x in eachrow(X)]...)

#TODO: One hot encode y_train

lambdas = 10.0 .^ [-5, -3, -1]
for lambda in lambdas
    #TODO: Fit a modoel to the training data
    
    #TODO: Compute the training and test error rates
    
    # Note that when you execute predictall(model,X), you will get a one-hot encoded prediction.
    # You will need to go back from a one-hot encoding to a vector of integer labels to correctly
    #  use the provided error_rate function
    
    @printf("Lambda = %.1e, Training error rate: %.2f, Test error rate: %.2f\n", lambda, train_error_rate, test_error_rate)
end
