using LinearAlgebra
using Statistics
using LaTeXStrings
using Random
using Plots
using Flux

include("readclassjson.jl")
include("rerm_lin_reg.jl")

data = readclassjson("logistic.json")

X_train = data["X_train"]
X_test = data["X_test"]
y_train = data["y_train"]
y_test = data["y_test"]

#############################

# Error rate function
function error_rate(yhat, y)
    return sum(yhat .!= y) / length(y)
end

# Logistic loss
function logistic_loss(yhat, y)
    #TODO: Implement this function
end

# Quadratic regularization function
function square_reg(theta)
    return norm(theta[2:end], 2).^2
end

#############################

mu = mean(X_train, dims=1)
sig = std(X_train, dims=1, corrected=false)

X_train = (X_train .- mu) ./ sig
X_test = (X_test .- mu) ./ sig

X_train = [ones(size(X_train, 1)) X_train]
X_test = [ones(size(X_test, 1)) X_test]

#TODO: Make the y vectors {-1, 1}-valued instead of {0, 1}-valued

lambdas = 10 .^range(-5, stop=5, length=10)

train_error_rates = []
test_error_rates = []

for lambda in lambdas
    #TODO: Fit a modoel to the training data
    
    #TODO: Compute the training and test error rates
    # Append the error rates you compute to the provided lists 
    #  train_error_rates and test_error_rates
end

p1 = plot(layout = (2, 1), legend = false)

plot!(p1[1], lambdas, train_error_rates, xscale=:log10, xlabel=L"\lambda", ylabel="error rate")
title!(p1[1], "Train error rates")

plot!(p1[2], lambdas, test_error_rates, xscale=:log10, xlabel=L"\lambda", ylabel="error rate")
title!(p1[2], "Test error rates")

savefig(p1, "logistic_reg.pdf")
