using Flux
using Random

function nn_multiclass_classification(X, Y, lambda, n_classes)
    Random.seed!(0)
    
    numiters=100
    
    d = size(X,2); m = size(Y,2)

    # You will tweak the following lines in order to change the architecture of the model 
    model = Chain(
        Dense(d, 10, relu),
        Dense(10, n_classes, sigmoid)
    )
    # The model outputs n_classes probabilities. We will choose the highest as our classification

    data = zip(eachrow(X), eachrow(Y))
	
    # logitcrossentropy is used for training classification models
    loss(x, y) = Flux.Losses.logitcrossentropy(model(x), y)
    reg() = sum([norm(model[i].weight, 2).^2 for i = 1:length(model)]) # Regularizer
    cost(x,y) = loss(x,y) + lambda*reg()
	
    # Training
    # Gradient descent optimiser with learning rate 0.5
    optimiser = Descent(0.5)

    println("Training...")
    
    for iter in 1:numiters
	    Flux.train!(cost, Flux.params(model), data, optimiser)
    end
    
    return model
end
